#!/usr/bin/env python2.2

import cgi
import cgitb; cgitb.enable()
import os
import sys
import string
import math

import JugMaster as Jug
from JugMaster.JugCGI import GetScriptUrl, WildcardsToSQL

Jug.DB.SetRole(Jug.DB.READER)

class ConfigObject:
	user_group = ""
	request_email = ""
	rewrite_urls_for_browsing = ""
	def __init__(self):
		#read the cmsjug site.config file
		siteconf = Jug.JugSubmit.JDLParser()
		siteconf.ParseFile("site.config")

		#extract information 
		self.user_group = str(siteconf.Eval("user_group"))
		self.request_email = str(siteconf.Eval("request_email"))
		self.rewrite_urls_for_browsing = str(siteconf.Eval("rewrite_urls_for_browsing"))
		if self.rewrite_urls_for_browsing:
			#Put it in environment so JugCGI sees it.
			os.environ["REWRITE_URLS_FOR_BROWSING"] = self.rewrite_urls_for_browsing

config = None
def GetConfig():
	global config
	if not config:
		config = ConfigObject()
	return config

def GetJugCGIUrl(p,params=None,extra_params=None):
	return Jug.JugCGI.GetScriptUrl(p,params=params,extra_params=extra_params)

def ShowTopMenu(form):
	print "<center>"
	print "<a href='" + GetScriptUrl(p="datasets") + "'>Datasets</a>"
	print "| <a href='" + GetScriptUrl(p="request") + "'>Request</a>"
	print "| <a href='" + GetScriptUrl(p="batch_status") + "'>Batch Status</a>"
	print "| <a href='" + GetScriptUrl(p="run_status") + "'>Run Status</a>"
	print "| <a href='" + GetScriptUrl(p="failures") + "'>Runs Finished</a>"
	print "| <a href='" + Jug.JugCGI.GetFileUrl(file="doc/index.html") + "'>Documentation</a>"
	print "</center>"

def ShowRequestForm(form):
	f = None

	if form.has_key("f"):
		f = form["f"].value

	config = GetConfig()

	print "<h1> UNDER CONSTRUCTION -- KEEP OUT! </h1>"

	title = "Dataset Request Forms"
	print "<h1>" + title + "</h1>"

	print "<ul>"
	print "<li><a href=" + GetScriptUrl(p="request",params={'f': "cmkin_to_digi"}) + ">cmkin to digi</a>"
	print "<li><a href=" + GetScriptUrl(p="request",params={'f': "oscar_to_digi"}) + ">oscar to digi</a>"
	print "</ul>"

	print "<hr width=20% align=center>"

	if f == "cmkin_to_digi":
		print "<form method=POST action='mailto:" + config.request_email + "?subject=CMSJug Dataset Request'>"
		print "name <input name=name><BR>"
		print "<input type=submit value='Submit'>"
		print "</form>"


def ShowDatasets(form):
	dataset = None

	if form.has_key("dataset"):
		dataset = form["dataset"].value

	config = GetConfig()

	constraint = "source = " + Jug.DB.Quote(config.user_group)

	constraint = constraint + " AND name not like '%.init' AND name not like '%.init.attach' "

	if dataset:
		constraint = constraint + " AND name " + WildcardsToSQL("*" + dataset + "*") + " "

	title = "Datasets produced for '" + cgi.escape(config.user_group) + "'"
	if dataset:
		title = title + " matching '" + cgi.escape(dataset) + "'"

	print "<h1>" + title + "</h1>"

	SQL = """
	  SELECT  batch_id,name,work_done,finished
	         ,substring(name,1,locate(".",name)-1) as dataset
			 ,notes,software,environment,next_run_id
	  FROM batch
	  WHERE """ + constraint  + """
	  ORDER BY dataset,batch_id
	"""
	q = Jug.DB.Query(SQL)

	rows = []
	attached_assignments = {}
	transferred_assignments = {}
	while 1:
		row = q.fetchone()
		if not row: break

		name = row[1]
		finished = row[3]
		if string.find(name,"attach") >= 0:
			if finished:
				attached_assignments[name] = 1
			continue #do not display attachment jobs
		if string.find(name,"transfer") >= 0:
			if finished:
				transferred_assignments[name] = "[b]"
			else:
				transferred_assignments[name] = "[t]"
			continue #do not display transfer jobs

		rows.append(row)

	print "<table border=1>"
	print "<tr>"
	print "<th>Name"
	print "<th>Events"
	print "<th>Status"
	print "<th>Pool Catalog"
	print "<th>Dataset"
	print "<th>Logs"
	for row in rows:
		batch_id = row[0]
		name = row[1]
		work_done = row[2]
		finished = row[3]
		dataset = row[4]
		notes = row[5]
		software = row[6]
		environment = row[7]
		next_run_id = row[8]

		params=Jug.EnvStringToDict(notes)
		env=Jug.EnvStringToDict(environment)

		dataset_path = ""
		for var in env.keys():
			if string.find(var,"OUTPUT_DATASET") >= 0:
				dataset_path = env[var]

		assignment_type = params.get("assignment_type")
		if not assignment_type:
			if string.find(name,"cmkin") >= 0:
				assignment_type = "cmkin"
			elif string.find(name,"oscar") >= 0:
				assignment_type = "oscar"
			elif string.find(name,"digi") >= 0:
				assignment_type = "digi"

		pool = ""
		if assignment_type <> "cmkin":
			pool = params.get("pool")
			if not pool:
				for line in string.split(software):
					fparams,fname = Jug.ExtractFileParams(line)
					if string.find(fname,"pool") >= 0:
						pool = os.path.join(fname,"PoolFileCatalog.xml")
						if string.find(pool,":") < 0:
							pool = "file:" + pool

		status = ""
		if not finished:
			if next_run_id:
				status = "Running"
			else:
				status = "Queued"
		elif not attached_assignments.get(name + ".attach") and assignment_type in ("oscar","digi"):
			status = "Attaching"
		else:
			status = "Done"

		transfer_status = transferred_assignments.get(name + ".transfer")
		if transfer_status:
			status = status + " <small>" + transfer_status + "</small>"



		print "<tr>"
		url = GetJugCGIUrl(p='batch_details',params={'batch': name})
		print "<td><a class=plainlink href='" + url + "'>" + cgi.escape(name) + "</a>"
		print "<td align=right>" + str(work_done)

		url = GetJugCGIUrl(p='batch_status',params={'batch': dataset + ".*"})
		print "<td align=center><a class=plainlink href='" + url + "'>" + status + "</a>"
		print "<td><small>" + str(pool) + "</small>&nbsp;"
		print "<td><small>" + str(dataset_path) + "</small>&nbsp;"

		print "<td><small>[<a href='" + \
			  GetScriptUrl(p="sample_log",params={'batch_id':batch_id}) + \
		      "'>sample</a>]</small>"
	print "</table>"

def GetSampleLogURL(form):
	batch_id = int(form["batch_id"].value)
	SQL = """
	  SELECT STRAIGHT_JOIN storage_url
	  FROM run,run_output
	  WHERE run.batch_id = """ + str(batch_id) + """
	  AND run.finished IS NOT NULL
	  AND run.worker_type = 'E'
	  AND run_output.batch_id = run.batch_id
	  AND run_output.run_id = run.run_id
	  AND (run_output.storage_name LIKE '%.log'
	  OR   run_output.storage_name LIKE '%.log.gz')
	  LIMIT 1
	  """
	log_q = Jug.DB.Query(SQL)
	example_log = ""
	while 1:
		log_row = log_q.fetchone()
		if not log_row: break

		example_log = log_row[0]
		break

	return example_log

def ShowPage(p,form):
	if not p:
		p = "datasets"
	if p == "datasets":
		ShowDatasets(form)
	elif p == "request":
		ShowRequestForm(form)
	else:
		Jug.JugCGI.ShowPage(p,form)

def PrintUsage():
	msg = """
USAGE: CMSJugCGI.py --install /path/to/cgi-bin/CMSJug.cgi

This will install a simple shell script that invokes CMSJugCGI.py
with the correct environment.  You may then view general status
in a web browser.

"""
	sys.stderr.write(msg)

def DoCGI():
	if not os.environ.has_key("SCRIPT_NAME"):
		#We must be run from the command-line
		import getopt
		long_options = [
			"help",
			"install"
		]
		options,args = getopt.getopt(sys.argv[1:],"h",long_options)

		install = 0

		for option,value in options:
			if option == "-h" or option == "--help":
				PrintUsage()
				sys.exit(0)
			elif option == "--install":
				install=1

		if not install or (install and len(args) != 1):
			PrintUsage()
			sys.exit(1)

		install_path = args[0]
		F = open(install_path,"w")
		F.write("#!/bin/sh\n")
		F.write("source " + os.environ["JUG_HOME"] + "/setup.sh\n")
		F.write("source " + os.environ["CMSJUG_HOME"] + "/setup.sh\n")
		F.write("exec ${CMSJUG_HOME}/cgi/CMSJugCGI.py\n")
		F.close()
		os.chmod(install_path,0755)

		print "Installed CGI invocation script in " + str(install_path)

		sys.exit(0)

	title = "CMSJug"
	form = cgi.FieldStorage()

	p = ""
	if form.has_key("p"):
		p = form["p"].value

	extra_path = os.environ.get("PATH_INFO")

	if extra_path:
		if string.find(extra_path,"/doc/jug/") == 0:
			extra_path = "/doc/" + extra_path[9:]
			Jug.JugCGI.ServeFile(extra_path)
		else:
			Jug.JugCGI.ServeFile(extra_path,os.environ.get("CMSJUG_HOME"))
		sys.exit(0)

	#load config info so we get url-rewriting info
	config = GetConfig()
	if p == "sample_log":
		url = GetSampleLogURL(form)
		if url:
			url_for_browsing = Jug.JugCGI.RewriteURLForBrowsing(url)
			Jug.JugCGI.RedirectToUrl(url_for_browsing)
			sys.exit(0)

	print "Content-Type: text/html"
	print

	print "<html>"
	print "<head>"
	print "<style>"
	print ".plainlink {text-decoration: none; color: black}"
	print ".plainlink:hover {color: purple}"
	print "TH.header {background: blue; color: white}"
	print "</style>"
	print "<title>" + title + "</title>"
	print "</head>"
	print "<body>"

	ShowTopMenu(form)

	ShowPage(p,form)

	print "</body>"
	print "</html>"

if __name__ == "__main__":
	DoCGI()
